searchNodes=[{"ref":"AwsExRay.html","title":"AwsExRay","type":"module","doc":"Preparation Setup your AWS environment. Run xray daemon on an EC2 instance which you want your application run on. https://docs.aws.amazon.com/xray/latest/devguide/xray-daemon.html USAGE trace = Trace.new() segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) do_your_job() AwsExRay.finish_tracing(segment) def do_your_job() do current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok # you need to do nothing. end end Multi Processes Following example doesn&#39;t work. start_subsegment returns always {:error, :out_of_xray}. Because the subsegment is not on the process which start tracing. Pay attention when you use Task.Supervisor or GenServer. segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) Task.Supervisor.start_child(MyTaskSupervisor, fn -&gt; #################################################################### # this function is executed on different process as root-segment!!! #################################################################### current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok end end) The solution. Call AwsExRay.Process.keep_tracing(process_which_starts_tracing) like following segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) tracing_pid = self() Task.Supervisor.start_child(MyTaskSupervisor, fn -&gt; AwsExRay.Process.keep_tracing(tracing_pid) current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok end end) Multi Servers [client] --&gt; [1: front_server] --&gt; [2: internal_api or job_worker] You can tracking Trace including (2) not only (1). If (2) server is HTTP server. You can put X-Amzn-Trace-Id into your requests HTTP headers. calling internal api on (1) If you use AwsExRay.HTTPoison, it&#39;s easy. all you have to do is to set :traced option. options = [traced: true] result = AwsExRay.HTTPoison.get(url, headers, options) received internal request on (2) If you setup AwsExRay.Plug, it automatically takes over tracing. defmodule MyInternalAPIRouter do use Plug.Router plug AwsExRay.Plug, name: &quot;my-internal-api&quot; WITHOUT SUPPORT LIBRARIES You can directory pass Trace value case AwsExRay.start_subsegment(&quot;internal-api-request&quot;, namespace: :remote) do {:error, :out_of_xray} -&gt; pass_job_in_some_way(%{ your_job_data: ... }) {:ok, subsegment} -&gt; pass_job_in_some_way(%{ your_job_data: ... trace_value: Subsegment.generate_trace_value(subsegment) }) AwsExRay.finish_subsegment(subsegment) end And job worker side, it can take over the Trace job = receive_job_in_some_way() case AwsExRay.Trace.parse(job.trace_value) do {:ok, trace} AwsExRay.start_tracing(trace, &quot;internal-job-name&quot;) :ok {:error, :not_found} -&gt; :ok end More Simple Interface If you don&#39;t need to put detailed parameters into segment/subsegment, You can do like following Segment trace = Trace.new() result = AwsExRay.trace(trace, &quot;root_segment_name&quot;, fn -&gt; do_your_job() end) This is same as, AwsExRay.finish_tracing(segment) segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) result = do_your_job() AwsExRay.finish_tracing(segment) result This way supports just only annotations trace = Trace.new() result = AwsExRay.trace(trace, &quot;root_segment_name&quot;, %{&quot;MyAnnotationKey&quot; =&gt; &quot;MyAnnotationValue&quot;}, fn -&gt; do_your_job() end) Subsegment opts = [namespace: :none] result = AwsExRay.subsegment(&quot;name&quot;, opts, fn trace_value -&gt; # trace_value is an empty string if this context is out of trace do_your_job() end) This is same as, current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) result = do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok # you need to do nothing. end result This way supports just only annotations opts = [namespace: :none] result = AwsExRay.subsegment(&quot;name&quot;, %{&quot;MyAnnotationKey&quot; =&gt; &quot;MyAnnotationValue&quot;}, opts, fn -&gt; do_your_job() end)"},{"ref":"AwsExRay.html#finish_subsegment/2","title":"AwsExRay.finish_subsegment/2","type":"function","doc":""},{"ref":"AwsExRay.html#finish_tracing/1","title":"AwsExRay.finish_tracing/1","type":"function","doc":""},{"ref":"AwsExRay.html#start_subsegment/2","title":"AwsExRay.start_subsegment/2","type":"function","doc":""},{"ref":"AwsExRay.html#start_tracing/1","title":"AwsExRay.start_tracing/1","type":"function","doc":""},{"ref":"AwsExRay.html#start_tracing/2","title":"AwsExRay.start_tracing/2","type":"function","doc":""},{"ref":"AwsExRay.html#subsegment/2","title":"AwsExRay.subsegment/2","type":"function","doc":""},{"ref":"AwsExRay.html#subsegment/3","title":"AwsExRay.subsegment/3","type":"function","doc":""},{"ref":"AwsExRay.html#subsegment/4","title":"AwsExRay.subsegment/4","type":"function","doc":""},{"ref":"AwsExRay.html#trace/2","title":"AwsExRay.trace/2","type":"function","doc":""},{"ref":"AwsExRay.html#trace/3","title":"AwsExRay.trace/3","type":"function","doc":""},{"ref":"AwsExRay.html#trace/4","title":"AwsExRay.trace/4","type":"function","doc":""},{"ref":"AwsExRay.Application.html","title":"AwsExRay.Application","type":"module","doc":"Application module which starts aws_ex_ray&#39;s root supervisor"},{"ref":"AwsExRay.Client.html","title":"AwsExRay.Client","type":"module","doc":"This module is a facade interface to send report-data to xray-daemons running on your localhost."},{"ref":"AwsExRay.Client.html#child_spec/1","title":"AwsExRay.Client.child_spec/1","type":"function","doc":""},{"ref":"AwsExRay.Client.html#send/1","title":"AwsExRay.Client.send/1","type":"function","doc":""},{"ref":"AwsExRay.Client.Behaviour.html","title":"AwsExRay.Client.Behaviour","type":"behaviour","doc":"Real client requires IO, so to enable mocking on test environment, provides a interface and swithable modules."},{"ref":"AwsExRay.Client.Behaviour.html#c:send/1","title":"AwsExRay.Client.Behaviour.send/1","type":"callback","doc":""},{"ref":"AwsExRay.Client.Sandbox.html","title":"AwsExRay.Client.Sandbox","type":"module","doc":""},{"ref":"AwsExRay.Client.Sandbox.html#child_spec/1","title":"AwsExRay.Client.Sandbox.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AwsExRay.Client.Sandbox.html#init/1","title":"AwsExRay.Client.Sandbox.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"AwsExRay.Client.Sandbox.html#send/1","title":"AwsExRay.Client.Sandbox.send/1","type":"function","doc":""},{"ref":"AwsExRay.Client.Sandbox.html#start_link/1","title":"AwsExRay.Client.Sandbox.start_link/1","type":"function","doc":""},{"ref":"AwsExRay.Client.Sandbox.Sink.html","title":"AwsExRay.Client.Sandbox.Sink","type":"module","doc":""},{"ref":"AwsExRay.Client.Sandbox.Sink.Behaviour.html","title":"AwsExRay.Client.Sandbox.Sink.Behaviour","type":"behaviour","doc":""},{"ref":"AwsExRay.Client.Sandbox.Sink.Behaviour.html#c:send/1","title":"AwsExRay.Client.Sandbox.Sink.Behaviour.send/1","type":"callback","doc":""},{"ref":"AwsExRay.Client.Sandbox.Sink.Ignore.html","title":"AwsExRay.Client.Sandbox.Sink.Ignore","type":"module","doc":""},{"ref":"AwsExRay.Client.Sandbox.Sink.Ignore.html#send/1","title":"AwsExRay.Client.Sandbox.Sink.Ignore.send/1","type":"function","doc":"Callback implementation for AwsExRay.Client.Sandbox.Sink.Behaviour.send/1."},{"ref":"AwsExRay.Client.UDPClient.html","title":"AwsExRay.Client.UDPClient","type":"module","doc":"This is a UDP client module which reports TRACE information to xray-daemon running on localhost."},{"ref":"AwsExRay.Client.UDPClient.html#child_spec/1","title":"AwsExRay.Client.UDPClient.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AwsExRay.Client.UDPClient.html#send/2","title":"AwsExRay.Client.UDPClient.send/2","type":"function","doc":""},{"ref":"AwsExRay.Client.UDPClient.html#start_link/1","title":"AwsExRay.Client.UDPClient.start_link/1","type":"function","doc":""},{"ref":"AwsExRay.Client.UDPClientSupervisor.html","title":"AwsExRay.Client.UDPClientSupervisor","type":"module","doc":"Supervise some UDP client (GenServer) for xray-daemon with poolboy. You con configure the number of pool-size and overflow. See also AwsExRay.Config."},{"ref":"AwsExRay.Client.UDPClientSupervisor.html#child_spec/1","title":"AwsExRay.Client.UDPClientSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AwsExRay.Client.UDPClientSupervisor.html#client_options/0","title":"AwsExRay.Client.UDPClientSupervisor.client_options/0","type":"function","doc":""},{"ref":"AwsExRay.Client.UDPClientSupervisor.html#pool_options/0","title":"AwsExRay.Client.UDPClientSupervisor.pool_options/0","type":"function","doc":""},{"ref":"AwsExRay.Client.UDPClientSupervisor.html#start_link/0","title":"AwsExRay.Client.UDPClientSupervisor.start_link/0","type":"function","doc":""},{"ref":"AwsExRay.Client.UDPClientSupervisor.html#start_link/1","title":"AwsExRay.Client.UDPClientSupervisor.start_link/1","type":"function","doc":""},{"ref":"AwsExRay.Config.html","title":"AwsExRay.Config","type":"module","doc":"Config Accessor Module Configuration config :aws_ex_ray, sampling_rate: 0.1, default_annotation: %{foo: &quot;bar&quot;}, default_metadata: %{bar: &quot;buz&quot;} keydefaultdescription sampling_rate0.1set number between 0.0 - 1.0. recommended that set 0.0 for &#39;test&#39; environment default_annotation%{}annotation parameters automatically put into segment/subsegment default_metadata%{}metadata parameters automatically put into segment/subsegment daemon_address127.0.0.1your xray daemon&#39;s IP address. typically, you don&#39;t need to customize this. daemon_port2000your xray daemon&#39;s port. typically, you don&#39;t need to customize this. default_client_pool_size10number of UDP client which connects to xray daemon default_client_pool_overflow100overflow capacity size of UDP client default_store_monitor_pool_size10number of tracing-process-monitor"},{"ref":"AwsExRay.Config.html#client_module/0","title":"AwsExRay.Config.client_module/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#client_pool_overflow/0","title":"AwsExRay.Config.client_pool_overflow/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#client_pool_size/0","title":"AwsExRay.Config.client_pool_size/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#daemon_address/0","title":"AwsExRay.Config.daemon_address/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#daemon_port/0","title":"AwsExRay.Config.daemon_port/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#default_annotation/0","title":"AwsExRay.Config.default_annotation/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#default_metadata/0","title":"AwsExRay.Config.default_metadata/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#get/2","title":"AwsExRay.Config.get/2","type":"function","doc":""},{"ref":"AwsExRay.Config.html#library_name/0","title":"AwsExRay.Config.library_name/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#library_version/0","title":"AwsExRay.Config.library_version/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#sampling_rate/0","title":"AwsExRay.Config.sampling_rate/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#sandbox_sink_module/0","title":"AwsExRay.Config.sandbox_sink_module/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#service_version/0","title":"AwsExRay.Config.service_version/0","type":"function","doc":""},{"ref":"AwsExRay.Config.html#store_monitor_pool_size/0","title":"AwsExRay.Config.store_monitor_pool_size/0","type":"function","doc":""},{"ref":"AwsExRay.HTTPClientUtil.html","title":"AwsExRay.HTTPClientUtil","type":"module","doc":"This module provides some utility functions for HTTP client"},{"ref":"AwsExRay.HTTPClientUtil.html#find_tracing_name/2","title":"AwsExRay.HTTPClientUtil.find_tracing_name/2","type":"function","doc":""},{"ref":"AwsExRay.HTTPClientUtil.html#get_response_content_length/1","title":"AwsExRay.HTTPClientUtil.get_response_content_length/1","type":"function","doc":""},{"ref":"AwsExRay.HTTPClientUtil.html#get_user_agent/1","title":"AwsExRay.HTTPClientUtil.get_user_agent/1","type":"function","doc":""},{"ref":"AwsExRay.HTTPClientUtil.html#put_response_error/3","title":"AwsExRay.HTTPClientUtil.put_response_error/3","type":"function","doc":""},{"ref":"AwsExRay.HTTPClientUtil.html#put_tracing_header/2","title":"AwsExRay.HTTPClientUtil.put_tracing_header/2","type":"function","doc":""},{"ref":"AwsExRay.Process.html","title":"AwsExRay.Process","type":"module","doc":"Segments in multiple processes Following example doesn&#39;t work. start_subsegment returns always {:error, :out_of_xray}. Because the subsegment is not on the process which start tracing. Pay attention when you use Task.Supervisor or GenServer. segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) Task.Supervisor.start_child(MyTaskSupervisor, fn -&gt; #################################################################### # this function is executed on different process as root-segment!!! #################################################################### current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok end end) The solution. Call AwsExRay.Process.keep_tracing(process_which_starts_tracing) like following segment = AwsExRay.start_tracing(trace, &quot;root_segment_name&quot;) tracing_pid = self() Task.Supervisor.start_child(MyTaskSupervisor, fn -&gt; AwsExRay.Process.keep_tracing(tracing_pid) current_trace = AwsExRay.start_subsegment(&quot;subsegment-name&quot;) do_some_work() case current_trace do {:ok, subsegment} -&gt; AwsExRay.finish_subsegment(subsegment) {:error, :out_of_xray} -&gt; :ok end end)"},{"ref":"AwsExRay.Process.html#keep_tracing/1","title":"AwsExRay.Process.keep_tracing/1","type":"function","doc":""},{"ref":"AwsExRay.Record.Error.html","title":"AwsExRay.Record.Error","type":"module","doc":"This module provides a data structure which represents error report."},{"ref":"AwsExRay.Record.Error.html#to_map/1","title":"AwsExRay.Record.Error.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Record.Error.html#t:t/0","title":"AwsExRay.Record.Error.t/0","type":"type","doc":""},{"ref":"AwsExRay.Record.Error.Cause.html","title":"AwsExRay.Record.Error.Cause","type":"module","doc":"This module provides a data structure which represents error.cause report."},{"ref":"AwsExRay.Record.Error.Cause.html#new/3","title":"AwsExRay.Record.Error.Cause.new/3","type":"function","doc":""},{"ref":"AwsExRay.Record.Error.Cause.html#to_map/2","title":"AwsExRay.Record.Error.Cause.to_map/2","type":"function","doc":""},{"ref":"AwsExRay.Record.Error.Cause.html#t:t/0","title":"AwsExRay.Record.Error.Cause.t/0","type":"type","doc":""},{"ref":"AwsExRay.Record.HTTPRequest.html","title":"AwsExRay.Record.HTTPRequest","type":"module","doc":"This module provides a data structure which represents http.request report."},{"ref":"AwsExRay.Record.HTTPRequest.html#to_map/1","title":"AwsExRay.Record.HTTPRequest.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Record.HTTPRequest.html#t:segment_type/0","title":"AwsExRay.Record.HTTPRequest.segment_type/0","type":"type","doc":""},{"ref":"AwsExRay.Record.HTTPRequest.html#t:t/0","title":"AwsExRay.Record.HTTPRequest.t/0","type":"type","doc":""},{"ref":"AwsExRay.Record.HTTPResponse.html","title":"AwsExRay.Record.HTTPResponse","type":"module","doc":"This module provides a data structure which represents http.response report."},{"ref":"AwsExRay.Record.HTTPResponse.html#new/2","title":"AwsExRay.Record.HTTPResponse.new/2","type":"function","doc":""},{"ref":"AwsExRay.Record.HTTPResponse.html#to_map/1","title":"AwsExRay.Record.HTTPResponse.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Record.HTTPResponse.html#t:t/0","title":"AwsExRay.Record.HTTPResponse.t/0","type":"type","doc":""},{"ref":"AwsExRay.Record.SQL.html","title":"AwsExRay.Record.SQL","type":"module","doc":"This module provides a data structure which represents sql report."},{"ref":"AwsExRay.Record.SQL.html#to_map/1","title":"AwsExRay.Record.SQL.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Record.SQL.html#t:t/0","title":"AwsExRay.Record.SQL.t/0","type":"type","doc":""},{"ref":"AwsExRay.Segment.html","title":"AwsExRay.Segment","type":"module","doc":"This module provides data structure which represents X-Ray&#39;s segment"},{"ref":"AwsExRay.Segment.html#add_annotation/3","title":"AwsExRay.Segment.add_annotation/3","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#add_annotations/2","title":"AwsExRay.Segment.add_annotations/2","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#finish/1","title":"AwsExRay.Segment.finish/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#finished?/1","title":"AwsExRay.Segment.finished?/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#generate_trace_value/1","title":"AwsExRay.Segment.generate_trace_value/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#new/2","title":"AwsExRay.Segment.new/2","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#sampled?/1","title":"AwsExRay.Segment.sampled?/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#set_error/2","title":"AwsExRay.Segment.set_error/2","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#set_http_request/2","title":"AwsExRay.Segment.set_http_request/2","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#set_http_response/2","title":"AwsExRay.Segment.set_http_response/2","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#to_json/1","title":"AwsExRay.Segment.to_json/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.html#t:t/0","title":"AwsExRay.Segment.t/0","type":"type","doc":""},{"ref":"AwsExRay.Segment.Formatter.html","title":"AwsExRay.Segment.Formatter","type":"module","doc":"This module provides a formatter functions for segment record"},{"ref":"AwsExRay.Segment.Formatter.html#to_json/1","title":"AwsExRay.Segment.Formatter.to_json/1","type":"function","doc":""},{"ref":"AwsExRay.Segment.Formatter.html#to_map/1","title":"AwsExRay.Segment.Formatter.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Stacktrace.html","title":"AwsExRay.Stacktrace","type":"module","doc":"This module provides a function which gathers stacktrace and format them for error.cause report."},{"ref":"AwsExRay.Stacktrace.html#stacktrace/1","title":"AwsExRay.Stacktrace.stacktrace/1","type":"function","doc":""},{"ref":"AwsExRay.Store.MonitorSupervisor.html","title":"AwsExRay.Store.MonitorSupervisor","type":"module","doc":"This module supervise monitor servers with poolboy. You con configure the number of pool-size. See also AwsExRay.Config."},{"ref":"AwsExRay.Store.MonitorSupervisor.html#child_spec/1","title":"AwsExRay.Store.MonitorSupervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AwsExRay.Store.MonitorSupervisor.html#start_link/0","title":"AwsExRay.Store.MonitorSupervisor.start_link/0","type":"function","doc":""},{"ref":"AwsExRay.Store.MonitorSupervisor.html#start_link/1","title":"AwsExRay.Store.MonitorSupervisor.start_link/1","type":"function","doc":""},{"ref":"AwsExRay.Store.MonitorSupervisor.html#start_monitoring/1","title":"AwsExRay.Store.MonitorSupervisor.start_monitoring/1","type":"function","doc":""},{"ref":"AwsExRay.Store.ProcessMonitor.html","title":"AwsExRay.Store.ProcessMonitor","type":"module","doc":"This GenServer monitors processes which is on context of xray-tracing. When a process dies, automatically delete information related to the process from ETS table."},{"ref":"AwsExRay.Store.ProcessMonitor.html#child_spec/1","title":"AwsExRay.Store.ProcessMonitor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AwsExRay.Store.ProcessMonitor.html#start_link/1","title":"AwsExRay.Store.ProcessMonitor.start_link/1","type":"function","doc":""},{"ref":"AwsExRay.Store.ProcessMonitor.html#start_monitoring/2","title":"AwsExRay.Store.ProcessMonitor.start_monitoring/2","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html","title":"AwsExRay.Store.Table","type":"module","doc":"This module provies functions to handle ETS table which contains process-and-segment mapping information."},{"ref":"AwsExRay.Store.Table.html#delete/0","title":"AwsExRay.Store.Table.delete/0","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#delete/1","title":"AwsExRay.Store.Table.delete/1","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#init/0","title":"AwsExRay.Store.Table.init/0","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#insert/3","title":"AwsExRay.Store.Table.insert/3","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#lookup/0","title":"AwsExRay.Store.Table.lookup/0","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#lookup/1","title":"AwsExRay.Store.Table.lookup/1","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#pop_subsegment/1","title":"AwsExRay.Store.Table.pop_subsegment/1","type":"function","doc":""},{"ref":"AwsExRay.Store.Table.html#push_subsegment/1","title":"AwsExRay.Store.Table.push_subsegment/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html","title":"AwsExRay.Subsegment","type":"module","doc":"This module provides data structure which represents X-Ray&#39;s subsegment"},{"ref":"AwsExRay.Subsegment.html#add_annotation/3","title":"AwsExRay.Subsegment.add_annotation/3","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#add_annotations/2","title":"AwsExRay.Subsegment.add_annotations/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#finish/2","title":"AwsExRay.Subsegment.finish/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#finished?/1","title":"AwsExRay.Subsegment.finished?/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#generate_trace_value/1","title":"AwsExRay.Subsegment.generate_trace_value/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#get_trace/1","title":"AwsExRay.Subsegment.get_trace/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#id/1","title":"AwsExRay.Subsegment.id/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#new/3","title":"AwsExRay.Subsegment.new/3","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#sampled?/1","title":"AwsExRay.Subsegment.sampled?/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_aws/2","title":"AwsExRay.Subsegment.set_aws/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_error/2","title":"AwsExRay.Subsegment.set_error/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_http_request/2","title":"AwsExRay.Subsegment.set_http_request/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_http_response/2","title":"AwsExRay.Subsegment.set_http_response/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_sql/2","title":"AwsExRay.Subsegment.set_sql/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#set_start_time/2","title":"AwsExRay.Subsegment.set_start_time/2","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#to_json/1","title":"AwsExRay.Subsegment.to_json/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.html#t:namespace/0","title":"AwsExRay.Subsegment.namespace/0","type":"type","doc":""},{"ref":"AwsExRay.Subsegment.html#t:t/0","title":"AwsExRay.Subsegment.t/0","type":"type","doc":""},{"ref":"AwsExRay.Subsegment.Formatter.html","title":"AwsExRay.Subsegment.Formatter","type":"module","doc":"This module provides a formatter functions for subsegment record"},{"ref":"AwsExRay.Subsegment.Formatter.html#to_json/1","title":"AwsExRay.Subsegment.Formatter.to_json/1","type":"function","doc":""},{"ref":"AwsExRay.Subsegment.Formatter.html#to_map/1","title":"AwsExRay.Subsegment.Formatter.to_map/1","type":"function","doc":""},{"ref":"AwsExRay.Trace.html","title":"AwsExRay.Trace","type":"module","doc":"This module provides data structure which represents X-Ray&#39;s trace"},{"ref":"AwsExRay.Trace.html#new/0","title":"AwsExRay.Trace.new/0","type":"function","doc":""},{"ref":"AwsExRay.Trace.html#parse/1","title":"AwsExRay.Trace.parse/1","type":"function","doc":""},{"ref":"AwsExRay.Trace.html#parse_or_new/1","title":"AwsExRay.Trace.parse_or_new/1","type":"function","doc":""},{"ref":"AwsExRay.Trace.html#to_string/1","title":"AwsExRay.Trace.to_string/1","type":"function","doc":""},{"ref":"AwsExRay.Trace.html#with_params/3","title":"AwsExRay.Trace.with_params/3","type":"function","doc":""},{"ref":"AwsExRay.Trace.html#t:t/0","title":"AwsExRay.Trace.t/0","type":"type","doc":""},{"ref":"AwsExRay.Trace.Formatter.html","title":"AwsExRay.Trace.Formatter","type":"module","doc":"This module provides parser and formatter functions for X-Ray Trace information"},{"ref":"AwsExRay.Trace.Formatter.html#parse/1","title":"AwsExRay.Trace.Formatter.parse/1","type":"function","doc":""},{"ref":"AwsExRay.Trace.Formatter.html#to_string/1","title":"AwsExRay.Trace.Formatter.to_string/1","type":"function","doc":""},{"ref":"AwsExRay.Util.html","title":"AwsExRay.Util","type":"module","doc":"This module provides some utility functions"},{"ref":"AwsExRay.Util.html#generate_model_id/0","title":"AwsExRay.Util.generate_model_id/0","type":"function","doc":""},{"ref":"AwsExRay.Util.html#generate_trace_id/0","title":"AwsExRay.Util.generate_trace_id/0","type":"function","doc":""},{"ref":"AwsExRay.Util.html#get_header/3","title":"AwsExRay.Util.get_header/3","type":"function","doc":""},{"ref":"AwsExRay.Util.html#now/0","title":"AwsExRay.Util.now/0","type":"function","doc":""},{"ref":"AwsExRay.Util.html#sample?/0","title":"AwsExRay.Util.sample?/0","type":"function","doc":""}]